import java.awt.*;
import java.awt.event.*;
import java.util.Random;

/**
*`R|[lgNX(Canvasp)<p>
*C[v
*/
public class MyCanvas extends Canvas implements Runnable{
	ObjectPool objectpool;
	KeyInput keyinput;
	Image imgBuf;
	Graphics gBuf;
	Random random;
	Title title;
	Score score;
	
	/**
	 * V[Ǘϐ<p>
	 * 0:^Cg 1:Q[̃C
	 */
	public int scene;
	static final int SCENE_TITLE = 0;
	static final int SCENE_GAMEMAIN = 1;
	
	
	public boolean gameover;
	int counter;
	
	
	//Ă
	static final int SHOT_PRESSED = 1;
	//ꂽ΂
	static final int SHOT_DOWN = 2;
	int shotkey_state;


	/**
	 * RXgN^
	 */
	MyCanvas()
	{
		//L[Xi
		keyinput = new KeyInput();
		addKeyListener(keyinput);
		setFocusable(true);				//tH[JX擾ł悤ɂB
		random = new Random();			//IuWFNg
		title = new Title();
		score = new Score();
	}

	/**
	 * <p>
	 * AvP[V̊JnA܂̓X^[gɌĂ΂A<br>
	 * Q[Ŏgϐ̏sB
	 */
	public void init()
	{
		objectpool = new ObjectPool();
		Score.loadScore();
		
		//V[̓^Cg
		scene = SCENE_TITLE;
		gameover = false;
		//x̏
		Level.initLevel();
		//XRȀ
		Score.initScore();
	}
	
	/**
	 * OXbhB
	 */
	public void initThread()
	{
		Thread thread = new Thread(this);
		thread.start();
	}
	
	/**
	 * `揈<p>
	 * repaint()̍ۂɌĂ΂āA
	 * ItXN[obt@摜Rs[\B
	 * @param g `OtBbNnh
	 */
	public void paint(Graphics g)
	{
		//ItXN[obt@̓eɃRs[
		g.drawImage(imgBuf, 0, 0, this);
	}

	/**
	 * C[v
	 */
	public void run()
	{
		//ItXN[obt@쐬
		imgBuf = createImage(500, 500);
		gBuf = imgBuf.getGraphics();
		
		for(counter = 0; ; counter++)
		{
			shotkey_state = keyinput.checkShotKey();

			//obt@NA
			gBuf.setColor(Color.white);
			gBuf.fillRect(0, 0, 500, 500);

			//V[Jڗp̕ϐŕ
			switch (scene)
			{
				//^Cg
				case 0:
					title.drawTitle(gBuf);
					score.drawScore(gBuf);
					score.drawHiScore(gBuf);
					
					//Xy[XL[ꂽ
					if (shotkey_state == SHOT_DOWN)
					{
						//Cʂɍs
						scene = SCENE_GAMEMAIN;
					}
					break;
				
				//Q[̃C
				case 1:
					gameMain();
					break;
			}

			//ĕ`v
			repaint();
			
			try{
				Thread.sleep(20);				//[ṽEFCg
			}
			catch(InterruptedException e)
			{}
		}
	}

	/**
	 * ʂNAȂ悤ɂ邽߁A
	 * update\bhI[o[ChB
	 * @param g XVOtBbNnh
	 */
	public void update(Graphics g)
	{
		paint(g);
	}
	
	/**
	 * Q[ʂ̃C
	 */
	void gameMain()
	{
		//Q[I[o[H
		if (objectpool.isGameover())
		{
			//Q[I[o[\
			title.drawGameover(gBuf);
			if (shotkey_state == SHOT_DOWN)
			{
				//XRAnCXRAɓKpAKv΃Z[u
				Score.compareScore();

				//Q[ď
				init();
			}
		}		
		
		//Փ˂̔
		objectpool.getColision();
		objectpool.movePlayer(keyinput);
		
		//GoԊuFxɉĒZȂ
		if (counter % (100 - Level.getLevel() * 10) == 0)
		{
			ObjectPool.newEnemy(100 + random.nextInt(300), 0);
		}

		//500t[o߂ƃx㏸
		if ((counter % 500) == 0)
		{
			Level.addLevel();
		}
		
		//Xy[XL[ĂAJE^R̔{ȂeiԊuɒeĂj
		if ((shotkey_state == SHOT_PRESSED)&&(counter % 3 == 0))
		{
			objectpool.shotPlayer();
		}

		//Q[IuWFNg̈ꊇ`揈
		objectpool.drawAll(gBuf);
		//XRA`
		score.drawScore(gBuf);
		score.drawHiScore(gBuf);
		
	}
}

