import java.awt.*;
import java.awt.event.*;


/**
*Q[IuWFNg̊ǗNX<p>
*vC[eAGȂǂ̃CX^X<p>
*IuWFNgm̑ݍpiՓˏȂǁjꊇǗB
*/
public class ObjectPool
{
	
	/**
	 * GCX^X炩ߐA߂Ă߂̔zB
	 */
	static Bullet[] bullet;
	/**
	 * GeCX^X炩ߐA߂Ă߂̔zB
	 */
	static Enemy[] enemy;
	/**
	 * vC[̒eCX^X炩ߐA߂Ă߂̔zB
	 */
	static MyBullet[] mybullet;
	/**
	 * CX^X炩ߐA߂Ă߂̔zB
	 */
	static Particle[] particle;

	/**
	 * vC[̃CX^XB
	 */
	Player player;
	
	//萔
	static final int DIST_PLAYER_TO_BULLET = 8;
	static final int DIST_PLAYER_TO_ENEMY = 16;
	static final int DIST_ENEMY_TO_MYBULLET = 16;
	
	//ő吔̐ݒ
	static final int BULLET_MAX = 100;
	static final int ENEMY_MAX = 100;
	static final int PARTICLE_MAX = 100;
	static final int MYBULLET_MAX = 5;
	

	/**
	 * RXgN^
	 */
	ObjectPool()
	{
		//vC[
		player = new Player(250, 400, 4);
		player.active = true;
		
		//e̔zmۂAz̗vfCX^X
		bullet = new Bullet[BULLET_MAX];
		for(int i = 0; i < bullet.length; i++)
		{
				bullet[i] = new Bullet();
		}

		//G̔zmۂAz̗vfCX^X
		enemy = new Enemy[ENEMY_MAX];
		for(int i = 0; i < enemy.length; i++)
		{
				enemy[i] = new Enemy(player);
		}
		
		//vC[̒e̔zmۂAz̗vfCX^X
		mybullet = new MyBullet[MYBULLET_MAX];
		for(int i = 0; i < mybullet.length; i++)
		{
				mybullet[i] = new MyBullet();
		}

		//̔zmۂAz̗vfCX^X
		particle = new Particle[PARTICLE_MAX];
		for(int i = 0; i < particle.length; i++)
		{
				particle[i] = new Particle();
		}
	}

	/**
	 * `揈BׂẴQ[IuWFNg`悷B
	 */
	public void drawAll(Graphics g)
	{
        doGameObjects(g, bullet);
        doGameObjects(g, enemy);
        doGameObjects(g, mybullet);
        doGameObjects(g, particle);
		player.draw(g);
	}

	/**
	 * Q[IuWFNg̔zQƂA
	 * activeɂȂĂCX^XړE`悷
	 */
    public void doGameObjects(Graphics g, GameObject[] objary)
    {
        for (int i = 0; i < objary.length; i++) {
			
            if (objary[i].active == true)
			{
                objary[i].move();
                objary[i].draw(g);				//Ϗ
            }
        }
    }
    
    /**
     * e̐Eiۂ͔z̃CX^Xg񂷁j
     * @param ix xW
     * @param iy yW
     * @param idirection 
     * @param ispeed x
     * @return eIDi󂫂-1j
     */
	public static int newBullet(double ix, double iy, double idirection, double ispeed)
	{
		for (int i = 0; i < BULLET_MAX; i++)
		{
			if ((bullet[i].active) == false)
			{
				bullet[i].activate(ix, iy, idirection, ispeed);
				return i;
			}
		}
		return -1;		//Ȃ
	}

    /**
     * G̐Eiۂ͔z̃CX^Xg񂷁j
     * @param ix xW
     * @param iy yW
     * @return GIDi󂫂-1j
     */
	public static int newEnemy(double ix, double iy)
	{
		for (int i = 0; i < ENEMY_MAX; i++)
		{
			if ((enemy[i].active) == false)
			{
				enemy[i].activate(ix, iy);
				return i;
			}
		}
		return -1;		//Ȃ
	}

    /**
     * vC[e̐Eiۂ͔z̃CX^Xg񂷁j
     * @param ix xW
     * @param iy yW
	 * @return vC[eIDi󂫂-1j
     */
	public static int newMyBullets(double ix, double iy)
	{
		for (int i = 0; i < MYBULLET_MAX; i++)
		{
			if ((mybullet[i].active) == false)
			{
				mybullet[i].activate(ix, iy);
				return i;
			}
		}
		return -1;		//Ȃ
	}

    /**
     * ̐Eiۂ͔z̃CX^Xg񂷁j
     * @param ix xW
     * @param iy yW
     * @param idirection 
     * @param ispeed x
	 * @return IDi󂫂-1j
     */
	public static int newParticle(double ix, double iy, double idirection, double ispeed)
	{
		for (int i = 0; i < PARTICLE_MAX; i++)
		{
			if ((particle[i].active) == false)
			{
				particle[i].activate(ix, iy, idirection, ispeed);
				return i;
			}
		}
		return -1;		//Ȃ
	}

	/**
	 * vC[e
	 */
	public void shotPlayer()
	{
		//v[[̎ełĂ
		if (player.active)
		{
			newMyBullets(player.x, player.y);
		}
	}

	/**
	 * vC[ړ鏈
	 * @param keyinput L[̓NX̃CX^XB
	 */
	public void movePlayer(KeyInput keyinput)
	{
		player.move(keyinput.getXDirection(), keyinput.getYDirection());
	}
	
	/**
	 * Q_Ԃ̋Ԃ
	 * @param ga Q[IuWFNg
	 * @param gb rQ[IuWFNg
	 * @return 
	 */
	public double getDistance(GameObject ga, GameObject gb)
	{
		//O̒藝
		double Xdiff = Math.abs(ga.x - gb.x);
		double Ydiff = Math.abs(ga.y - gb.y);
		return Math.sqrt(Math.pow(Xdiff,2) + Math.pow(Ydiff,2));
	}

	/**
	 * Փ˔
	 */
	public void getColision()
	{
		//evsvC[̏Փ
        for (int i = 0; i < bullet.length; i++) {
			if ((bullet[i].active)&&(player.active))
			{
				//蔻
				if (getDistance(player, bullet[i]) < DIST_PLAYER_TO_BULLET)
				{
					//vC[ŁiȂ邾j
					player.active = false;

					//𐶐
					for (int j = 0; j < 360; j += 20)
					{
						newParticle(player.x, player.y, j, 2);
					}

					//e
					bullet[i].active = false;
				}
			}
        }

		//vC[̒evsG̏Փ
        for (int i = 0; i < enemy.length; i++) {
			if (enemy[i].active == true)
			{
				for (int j = 0; j < mybullet.length; j++)
				{
					if (mybullet[j].active == true)
					{
						//蔻
						if (getDistance(enemy[i], mybullet[j]) < DIST_ENEMY_TO_MYBULLET)
						{
							newParticle(mybullet[j].x, mybullet[j].y, 270, 2);
							//G̗̑͂炷
							enemy[i].hit();
							//e
							mybullet[j].active = false;
						}
					}
				}
			}
        }

		//GvsvC[̏Փ
        for (int i = 0; i < enemy.length; i++) {
			if ((enemy[i].active)&&(player.active))
			{
				//蔻
				if (getDistance(player, enemy[i]) < DIST_PLAYER_TO_ENEMY)
				{
					//vC[ŁiȂ邾j
					player.active = false;

					//𐶐
					for (int j = 0; j < 360; j += 20)
					{
						newParticle(player.x, player.y, j, 2);
					}
					//G͏łȂ
				}
			}
        }

	}
	
	/**
	 * Q[I[o[ǂԂ
	 * @return Q[I[o[Ȃtrue
	 */
	public boolean isGameover()
	{
		return !player.active;
	}
	
	
	
}
